SET SQL DIALECT 3;

CREATE DATABASE 'DEMO.GDB'
USER 'SYSDBA' PASSWORD 'masterkey'
PAGE_SIZE 1024
DEFAULT CHARACTER SET WIN1250;



/* Generators definitions */

CREATE GENERATOR HISTORY_ID_GEN ;
CREATE GENERATOR QUEUE_ID_GEN ;
SET GENERATOR HISTORY_ID_GEN TO 0;

SET GENERATOR QUEUE_ID_GEN TO 77;



/* Tables definitions */

CREATE TABLE QUEUE (
    ID INTEGER NOT NULL,
    PHONE VARCHAR (15) character set WIN1250 collate WIN1250,
    MSG VARCHAR (1000) character set WIN1250 collate WIN1250,
    SCRIPT VARCHAR (200) character set WIN1250 collate WIN1250,
    SENDTIME TIMESTAMP,
    TRY SMALLINT DEFAULT 0,
    ERRORNUM SMALLINT DEFAULT 0,
    STATUS SMALLINT DEFAULT 0,
    PARAM VARCHAR (10000) character set WIN1250 collate WIN1250);



/* Primary keys definition */

ALTER TABLE QUEUE ADD CONSTRAINT PK_QUEUE PRIMARY KEY (ID);


/* Indices definition */

CREATE UNIQUE INDEX PK_QUEUE ON QUEUE (ID);

SET TERM ^ ;

/* Triggers definition */



/* Trigger: AI_QUEUE_ID */
CREATE TRIGGER AI_QUEUE_ID FOR QUEUE ACTIVE
BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
      NEW.ID = GEN_ID(QUEUE_ID_GEN, 1);
  if (NEW.sendtime IS NULL) then NEW.sendtime = current_timestamp;
END
^

SET TERM ; ^